IndexDeletionPolicy (Lucene 2.4.1 API)
Keywords: org.apache.lucene.index.IndexDeletionPolicy interface

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.index
Interface IndexDeletionPolicy

All Known Implementing Classes:
  KeepOnlyLastCommitDeletionPolicy, SnapshotDeletionPolicy

    public interface IndexDeletionPolicy

Expert: policy for deletion of stale `index commits`.

Implement this interface, and pass it to one of the `IndexWriter` or `IndexReader` constructors, to customize when older `point-in-time commits` are deleted from the index directory. The default deletion policy is `KeepOnlyLastCommitDeletionPolicy`, which always removes old commits as soon as a new commit is done (this matches the behavior before 2.2).

One expected use case for this (and the reason why it was first created) is to work around problems with an index directory accessed via filesystems like NFS because NFS does not provide the "delete on last close" semantics that Lucene's "point in time" search normally relies on. By implementing a custom deletion policy, such as "a commit is only removed once it has been stale for more than X minutes", you can give your readers time to refresh to the new commit before `IndexWriter` removes the old commits. Note that doing so will increase the storage requirements of the index. See LUCENE-710 for details.

Method Summary
`void` | `onCommit(List commits)` This is called each time the writer completed a commit.
`void` | `onInit(List commits)` This is called once when a writer is first instantiated to give the policy a chance to remove old commit points.

Method Detail

### onInit

    void onInit(List commits)
                throws IOException

  This is called once when a writer is first instantiated to give the policy a chance to remove old commit points.

  The writer locates all index commits present in the index directory and calls this method. The policy may choose to delete some of the commit points, doing so by calling method `delete()` of `IndexCommit`.

  Note: the last CommitPoint is the most recent one, i.e. the "front index state". Be careful not to delete it, unless you know for sure what you are doing, and unless you can afford to lose the index content while doing that.

  Parameters:
    `commits` - List of current `point-in-time commits`, sorted by age (the 0th one is the oldest commit).
  Throws:
    `IOException`

### onCommit

    void onCommit(List commits)
                  throws IOException

  This is called each time the writer completed a commit. This gives the policy a chance to remove old commit points with each commit.

  The policy may now choose to delete old commit points by calling method `delete()` of `IndexCommit`.

  If writer has `autoCommit = true` then this method will in general be called many times during one instance of `IndexWriter`. If `autoCommit = false` then this method is only called once when `IndexWriter.close()` is called, or not at all if the `IndexWriter.abort()` is called.

  Note: the last CommitPoint is the most recent one, i.e. the "front index state". Be careful not to delete it, unless you know for sure what you are doing, and unless you can afford to lose the index content while doing that.

  Parameters:
    `commits` - List of `IndexCommit`, sorted by age (the 0th one is the oldest commit).
  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2009 Apache Software Foundation. All Rights Reserved.